<template>
  <el-row :gutter="20" align="middle" class="clientsPage">
    <el-col :span="12" class="headBlock">
      <h1>{{ this.$route.meta.pageTitle }}</h1>
    </el-col>
    <el-col :span="12" class="text-right">
      <el-button type="primary" class="bigButton" @click="this.$router.push({name: 'AddPerson'})">Добавить <img src="@/assets/clients/add.svg" class="icon-image" alt=""></el-button>
    </el-col>
    <el-col :span="12" class="mtBlock">
      <div class="searchBlock">
        <el-input placeholder="Поиск"/>
        <img src="@/assets/search.svg" class="icon-image" alt="">
      </div>
    </el-col>
    <el-col :span="12" class="text-right mtBlock">
      <el-button type="info" class="bigButton">Фильтры <img src="@/assets/clients/filter.svg" class="icon-image" alt=""></el-button>
    </el-col>
    <el-col>
      <el-row :gutter="20" class="clientsBlock" v-loading="loading">
        <el-col v-for="item in persons" v-bind:key="item.id">
          <ClientComponent :client="item"></ClientComponent>
        </el-col>
      </el-row>
    </el-col>
  </el-row>
</template>

<script>
import ClientComponent from "@/views/cabinet-components/ClientComponent";
import {GET_PERSONS} from "@/store/modules/PersonModule";

export default {
  components:{
    ClientComponent
  },
  data:()=>({
    loading: true,
    persons:[],
  }),
  methods:{
    async getPersons() {
      try {
        this.loading = true;
        const data = await this.$store.dispatch(GET_PERSONS, this.$route.meta.personRole);
        this.persons = data.data;
        this.loading = false;
      } catch (e) {
        this.$message.error(e.response.data.error);
      }
    }
  },
  watch: {
    '$route'() {
      if(this.$route.meta.personRole){
        this.getPersons();
      }
    }
  },
  created() {
    this.getPersons();
  }
}
</script>